﻿#!/usr/bin/python
# -*- coding: UTF-8 -*-
#!/bin/python
# *** version 0.3.0 ***

#from typing import List
import logging
#import configparser
import subprocess
import time
import os
import re
import datetime
import random
import sys, getopt
#import glob
from datetime import datetime
import numpy as np
#from collections import defaultdict
#testcase_summary = defaultdict(int)

logger = None
OUTPUT_DIR = None
# set up regular expressions
# use https://regexper.com to visualise these if required
rx_dict = {
    'CMPChecker': re.compile(r'CMPChecker = (?P<CMPChecker>.*)\n'),
}

testArray = [[0]*4]*6
funcArray = [['uncheck',"WVR_GetProjection()",'0','', ''], #0
             ['uncheck',"WVR_GetClippingPlaneBoundary()",'0','', ''], #1
             ['uncheck',"WVR_GetInteractionMode()",'0','', ''], #2
             ['uncheck',"WVR_GetCurrentControllerModel()",'0','', ''], #3
             ['uncheck',"WVR_StartHandTracking()",'0','', ''], #4 return val WVR_SUCCESS is 0, need check msg
             ['uncheck',"WVR_GetHandTrackingData()",'0','', ''], #5  return val WVR_SUCCESS is 0, need check msg
             ['uncheck',"WVR_GetCurrentNaturalHandModel()",'0','', ''], #6
#             ['uncheck',"Hand interaction mode",'0','', ''], #7
#             ['uncheck',"Customized play area boundary",'0','', ''], #8
             ['uncheck',"WVR_GetParameters:CameraImage()",'0','', ''],
             ['uncheck',"WVR_ShowPassthroughOverlay()",'0','', ''],
             ['uncheck',"WVR_StartHandGesture()",'0','', ''],
             ['uncheck',"WVR_ControllerSupportElectronicHand()",'0','', ''],
             ['uncheck',"WVR_StartTracker()",'0','', ''],
             ['uncheck',"WVR_GetCtrlerModelAnimNodeData()",'0','', ''],
             ['uncheck',"setArmModelCenterMode()",'0','', '']]
#             ['uncheck',"WVR_ReleaseNatureHandModel()",'0','']

# this means runtime(server) support result, SDK need to further check
#               print log, feature name, runtime supp(0/1), SDK supp(version)
featureArray = [['uncheck',"Feature_PassthroughImage",		0, 1, '', ' '],
                ['uncheck',"Feature_PassthroughOverlay",	0, 5, '', 'WVR_ShowPassthroughOverlay'],
				['uncheck',"Feature_HandTracking",			0, 7, '', 'WVR_StartHandTracking'],
				['uncheck',"Feature_HandGesture",			0, 7, '', 'WVR_StartHandGesture' ],
				['uncheck',"Feature_ElectronicHand",		0, 7, '', 'WVR_ControllerSupportElectronicHand'],
				['uncheck',"Feature_ColorGamutsRGB",		0, 8, '', ' '],
				['uncheck',"Feature_ColorGamutP3",			0, 8, '', ' '],
                ['uncheck',"Feature_Tracker",				0, 8, '', 'WVR_StartTracker'],
                ['uncheck',"Feature_EyeTracking",			0, 6, '', 'WVR_StartEyeTracking'],
                ['uncheck',"Feature_EyeExp",				0, 9, '', 'WVR_StartEyeExp'],
                ['uncheck',"Feature_LipExp",				0, 9, '', 'WVR_StartLipExp'],
                ['uncheck',"none",		0, 0, '', ''],
                ['uncheck',"none",		0, 0, '', ''],
                ['uncheck',"none",		0, 0, '', ''],
                ['uncheck',"none",		0, 0, '', ''],
                ['uncheck',"none",		0, 0, '', ''],
                ['uncheck',"none",		0, 0, '', ''],
				['uncheck',"none",		0, 0, '', '']]

#appInfoArray = [['1' for j in range(2)] for i in range(5)]
appInfoArray = [['PackageName',"0"], #0
                ['Runtime',0], #1
				['SDK',0], #2
				['version name',"0"], #3
				['version code',"0"]] #4
#				['Hand interaction mode',"0"],#5
#				['Customized play area boundary',"0"]]#6
pointArray = ["1 -> Need to view result. No pass to use the WVR_GetProjection API may result in image overlapping or abnormal images.",
"2 -> Need to view result. No pass to use the WVR_GetClippingPlaneBoundary API may result in image overlapping or abnormal images. \n[Notice] Use 1 or 2 API should be able to get the correct projection effect.",
"",
"4 -> Failure to use the SDK controller model API may result in wrong controller image.",
"5 -> Failure to use the SDK Start Hand Tracking API may not use the hand feature.",
"6 -> Failure to use the SDK hand tracking data API may result in wrong hand feature and wrong hand image.",
"7 -> Failure to use the SDK hand model API may result in wrong hand image.",
#"8 -> Not support means that the default interaction mode is used.",
#"9 -> Not support means that the default game area boundary is used.",
"8 -> Pass means the camera image can be obtained. Vive Wave Runtime 4.1.0 above supports limited access on camera API. \nFail to get camera image may result in out-of-bounds passthrough not being displayed. If fail please contact to Wave. https://hub.vive.com/storage/docs/zh-tw/NativeCompatibilityGuides.html",
"9-14 -> These are the APIs that belong to the above Wave features. If the content wants to use the feature, it should call the corresponding API."]
#                                                        supp, runtime,  , API
wvrfeatureArray = [['check',"Customized play area boundary",0, 6, '', ' '],
                   ['check',"Camera Image access by code",	0, 7, '', 'WVR_GetParameters'],
                   ['check',"Controll model Animation",	0, 7, '', 'WVR_GetCtrlerModelAnimNodeData'],
                   ['check',"Hand interaction mode", 0, 7, '', ' '],
                   ['check',"Hand model",0, 7, '', 'WVR_GetCurrentNaturalHandModel'],
                   ['check',"Center hand mode",	0, 8, '', 'setArmModelCenterMode']]
				   
wvrfeatureRSArray = []
wvrInputArray = [[0,'WVR_InputId_0', "System"],
                 [1,'WVR_InputId_1', "Menu"],
                 [2,'WVR_InputId_2', "Grip"],
                 [3,'WVR_InputId_3', "DPad Left"],
                 [4,'WVR_InputId_4', "DPad Up"],
                 [5,'WVR_InputId_5', "DPad Right"],
                 [6,'WVR_InputId_6', "DPad Down"],
                 [7,'WVR_InputId_7', "Volume Up"],
                 [8,'WVR_InputId_8', "Volume Down"],
                 [9,'WVR_InputId_9', "Digtal Trigger"],
                 [10,'WVR_InputId_10', "A button"],
                 [11,'WVR_InputId_11', "B button"],
                 [12,'WVR_InputId_12', "X button"],
                 [13,'WVR_InputId_13', "Y button"],
                 [14,'WVR_InputId_14', "Hmd back button"],
                 [15,'WVR_InputId_15', "Hmd Enter button"],
                 [16,'WVR_InputId_16', "Touchpad"],
                 [17,'WVR_InputId_17', "Trigger"],
                 [18,'WVR_InputId_18', "Thumbstick input device"],
                 [19,'WVR_InputId_19', "Parking input device"],
                 [20,'WVR_InputId_Alias1_System', "System"],
                 [21,'WVR_InputId_Alias1_Menu', "Menu"],
                 [22,'WVR_InputId_Alias1_Grip', "Grip"],
                 [23,'WVR_InputId_Alias1_DPad_Left', "DPad Left"],
                 [24,'WVR_InputId_Alias1_DPad_Up', "DPad Up"],
                 [25,'WVR_InputId_Alias1_DPad_Right', "DPad Right"],
                 [26,'WVR_InputId_Alias1_DPad_Down', "DPad Down"],
                 [27,'WVR_InputId_Alias1_Volume_Up', "Volume Up"],
                 [28,'WVR_InputId_Alias1_Volume_Down', "Volume Down"],
                 [29,'WVR_InputId_Alias1_Bumper', "Bumper"],
                 [30,'WVR_InputId_Alias1_A', "A button"],
                 [31,'WVR_InputId_Alias1_B', "B button"],
                 [32,'WVR_InputId_Alias1_X', "X button"],
                 [33,'WVR_InputId_Alias1_Y', "Y button"],
                 [34,'WVR_InputId_Alias1_Back', "Hmd back button"],
                 [35,'WVR_InputId_Alias1_Enter', "Hmd Enter button"],
                 [36,'WVR_InputId_Alias1_Touchpad', "Touchpad"],
                 [37,'WVR_InputId_Alias1_Trigger', "Trigger"],
                 [38,'WVR_InputId_Alias1_Thumbstick', "Thumbstick input device"],
                 [39,'WVR_InputId_Alias1_Parking', "Parking input device"]]
inputMatchArrary = [] #[DST, input id, capability, axis_type, SRC, input id, capability, axis_type] , SRC是DS(device service)端, DST是指client端

#      inputId        0 1 2 3 4 5 6 7 8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39
appGetRButtonArray = [0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
appGetRTouchArray =  [0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
appGetLButtonArray = [0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
appGetLTouchArray =  [0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
appGetHMDButtonArray = [0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
appGetHMDTouchArray =[0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
def _parse_line(line):
    """
    Do a regex search against all defined regexes and
    return the key and match result of the first matching regex

    """
    for key, rx in rx_dict.items():
        match = rx.search(line)
        if match:
            print(key, match)
            return key, match
    # if there are no matches
    return None, None


def doCompatibilityIdentify(subline):
    return;

def doWVRFeatureCheck(subline):
    return

def doCompatibilitySummary():
    global funcArray
    for i in range(len(funcArray)) :
        for j in range(len(funcArray[i])) :
            print(funcArray[j][0], '/ ',funcArray[j][1])
            #for k in range(len(funcArray[i][j])) :
                #print(i,': ',funcArray[i][j][k], '/' , funcArray[i][j][k], end=" ")
            #print('\n')
        print('\n')
    return

#----------------------------------------------------------------------------------------------------------#
def prepareCompatibilityData():
    global testArray
    print('prepareCompatibilityData', testArray, '\n')
    #testArray[0].insert(0,0)
    #testArray[0].insert(0,1)
    #testArray[1].insert(1,0)
    #testArray[1].insert(1,1)
    testArray[1][1]='2' #asign array
    testArray.insert(5,[])
    testArray[5].insert(0,1)
    testArray[5].insert(1,1)
    testArray[5].insert(2,1)
    testArray[5].insert(3,1)
    print('prepareCompatibilityData', testArray[2][1])
    print('prepareCompatibilityData testArray', testArray, '\n')

    a = init_list([4, 3, 2], val=0)
    print(a)
    for i in range(len(a)) :
        for j in range(len(a[i])) :
            for k in range(len(a[i][j])) :
                print(a[i][j][k], end=" ")
            print(',')
        print('\n')
    return
#----------------------------------------------------------------------------------------------------------#
def init_list(dims, val):
    if len(dims) == 0:
        raise ValueError("Requires at least 1 dimension.")

    if len(dims) == 1:
        return [val for _ in range(dims[0])]

    return [init_list(dims[1:], val=val) for _ in range(dims[0])]
#[[[0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0]]]
#----------------------------------------------------------------------------------------------------------#
def systemCmd(cmd, timeout=180):
    p = subprocess.Popen(args=cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    try:
        stdout, stderr = p.communicate(timeout=timeout)
        time.sleep(3)
    except subprocess.TimeoutExpired as e:
        logger.error("...    |--- SystemCmd: {} Timeout".format(cmd))
        stdout, stderr = "", str(e)
        p.kill()

    return stdout, stderr
#----------------------------------------------------------------------------------------------------------#
pkgName = ""
sdkVersion=""
targetSdkVersion = ""
inputfile = ''
outputfile = ''
apkfile = ''
pkgfile = ''
data = []  # create an empty list to collect the data

def prepareAndroidManifest():
    global sdkVersion, targetSdkVersion, pkgName, apkfile
    #subprocess.run(["aapt", "dump", "badging", "VRMeeting.apk", " > ", "manifest.txt"])
    #os.system("aapt dump badging internal.cmp_test-debug.apk > out-manifest.txt")
    #os.system("aapt dump badging vrslauncher.apk > out-manifest.txt")
    cmd = "aapt dump badging %s > %s" % (apkfile,"out-manifest.txt")
    os.system(cmd)

    with open('out-manifest.txt', 'r') as file_object:
        line = file_object.readline()
        while line:
            if (line.startswith('sdkVersion:')):
                sdkVersion = line[12:14]
                print('Android sdkVersion:', sdkVersion)
            elif (line.startswith('targetSdkVersion:')):
                targetSdkVersion = line[18:20]
                print('Android targetSdkVersion:', targetSdkVersion)
            #elif (line.startswith('uses-permission')):
                #print('use-permission declare:', line.partition("name='")[2].partition("'")[0])
                #data.append('use-permission declare:'+ line.partition("name='")[2].partition("'")[0])
            elif (line.startswith('  uses-feature: name=')):
                print('use-feature declare:', line.partition("name='")[2].partition("'")[0])
                data.append('use-permission declare:'+ line.partition("name='")[2].partition("'")[0])

            line = file_object.readline()
    return sdkVersion, targetSdkVersion;

def preparePackageInfo():
    global pkgName, pkgfile
    os.system("adb shell dumpsys package pkgfile > out-dumpsyspkg.txt")
#----------------------------------------------------------------------------------------------------------#

Tag1 = "CMPChecker::"
def main(argv):
    global sdkVersion, targetSdkVersion, pkgName, appGetLButtonArray, appGetLTouchArray, appGetRButtonArray, appGetRTouchArray, inputfile, outputfile, apkfile, pkgfile

    try:
       opts, args = getopt.getopt(argv,"hi:o:a:p",["ifile=","ofile=","afile=","pfile="])
    except getopt.GetoptError:
       print('CMPChecker.py -i <inputfile> -o <outputfile> -a <apkfile>')
       sys.exit(2)

    for opt, arg in opts:
       #print('for opt', opts)
       if opt == '-h':
          #print('CMPChecker.py -i <inputfile> -o <outputfile>')
          sys.exit()
       elif opt in ("-i", "--ifile"):
          inputfile = arg
       elif opt in ("-o", "--ofile"):
          outputfile = arg
       elif opt in ("-a", "--afile"):
          apkfile = arg
       elif opt in ("-p", "--pfile"):
          pkgfile = arg

    print('Parsing start ......')
    #print(len(appGetRButtonArray)) #print(len(appGetRTouchArray))
    #print(len(appGetLButtonArray)) #print(len(appGetLTouchArray))
    #print(len(appGetHMDButtonArray)) #print(len(appGetHMDTouchArray))
    #preparePackageInfo()
    #APKsdkVersion, APKtargetSdkVersion = prepareAndroidManifest()
    #prepareCompatibilityData()
    #doCompatibilitySummary()
    for x in range(len(appInfoArray)):#len(d3), app amount
        #for i in range(len(appInfoArray[x])) :
            #print('(',x,i,')=',d3[x][i],',')
            #print('LOG','app index:', x)
            print('')#print('LOG','(x,i,j)','key',',','value')
            #print('(x,i,j)',appInfoArray[x][0],', ',appInfoArray[x][1])
            ##for j in range(len(d3[x][i])) :

    str1 = '11-24 07:58:43.460 28602 28718 I VRPlatform: setCompatibilityOutputData() CMPChecker::WVR_GetTransformFromEyeToHead=1=Using'
    #print(str1.partition('CMPChecker::')[2].split('=')[0])
    str2 = '11-24 07:58:42.841 28602 28718 I VRPlatform: checkCompatibilitySupport() CMPChecker::Customized play area boundary=Not Support'
    #print(str2.partition('CMPChecker::')[2].split('='))

    #data = []  # create an empty list to collect the data
    # open the file and read through it line by line
    with open(inputfile, 'r', errors='ignore') as file_object: #, encoding="utf-8"
        line = file_object.readline()
        while line:
            #print('new line -------------------------------------------------------------------------')
            #print('start in',line.index('CMPChecker::'))
            datasize = len(line.split('\n')[0].partition('CMPChecker::')[2].split('='))
            #print('LOG','data set size:', datasize, line.split('\n')[0].partition('CMPChecker::')[2].split('='))

            if datasize == 4:
                deviceId = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]
                inputId = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[3]


                if ('WVR_GetInputTouchState()' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
                    if (int(inputId)>len(appGetHMDTouchArray) or int(inputId)>len(appGetLTouchArray) or int(inputId)>len(appGetRTouchArray)):
                        print('InputTouch inputId out of defination, will break parse. Please contact wave to check log.\n\n')
                        break
                    #appGetButtonArray.append([line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0], val])
                    if ('1' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        appGetHMDTouchArray[int(inputId)] = 1;
                        #print('WVR_GetInputTouchState()', inputId)
                    elif('2' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        appGetLTouchArray[int(inputId)] = 1;
                        #print('WVR_GetInputTouchState()', inputId)
                    elif('3' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        #print('WVR_GetInputTouchState()', inputId)
                        appGetRTouchArray[int(inputId)] = 1;
                elif ('WVR_GetInputButtonState()' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
                    if (int(inputId)>len(appGetHMDButtonArray) or int(inputId)>len(appGetLButtonArray) or int(inputId)>len(appGetRButtonArray)):
                        print('InputButton inputId out of defination, will break parse. Please contact wave to check log.\n\n')
                        break
                    #appGetButtonArray.append([line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0], val])
                    #print('WVR_GetInputButtonState()', inputId)
                    if ('1' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        appGetHMDButtonArray[int(inputId)] = 1;
                    elif('2' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        appGetLButtonArray[int(inputId)] = 1;
                    elif('3' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]):
                        #print('WVR_GetInputButtonState()', inputId)
                        appGetRButtonArray[int(inputId)] = 1;
                elif ('InputMapper_DumpMap()' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
                    #InputMapper DST vs SRC result
                    # in parser : devType, DST, input, cap, axis, SRC, input, cap, axis_type, pair count
                    # from logcat       0,   1,     2,   3,    4,   5,     6,   7,         8,          9
                    #print('LOG','device Type(1:HMD, 2:R controller, 3:L controller): ', line.split('\n')[0].partition('CMPChecker::')[2].split('=')[3], '/count: ',line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[8])
                    if ([line.split('\n')[0].partition('CMPChecker::')[2].split('=')[3], #device idx
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[0],
                    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[1],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[2],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[3],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[4],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[5],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[6],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[7],
					line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[8]] not in inputMatchArrary):
                        inputMatchArrary.append([line.split('\n')[0].partition('CMPChecker::')[2].split('=')[3], #device idx
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[0],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[1],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[2],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[3],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[4],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[5],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[6],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[7],
					    line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2].split(',')[8]])
			    #print(4444)
            elif datasize == 3:
                msg = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1]
                val = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2]
                if (('WVR_GetInteractionMode()' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]) and val=='4'):
                    #print(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0], line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2])
                    funcArray[2][0]='check'
                    funcArray[2][2]=val #funcArray[0][i][3]=val
                    funcArray[2][3]=msg #funcArray[0][i][2]=msg
				# ..................................
                #i = 0
                #for func in funcArray:
                for i in range(len(funcArray)):
                    #if ('WVR_Init()' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
				    #appIndex = 0;
                    #print('for start:',i,'func', func)
                    #print(func[i],' / ',line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0])
                    #print(funcArray[i][1],"/",funcArray[i][2])
                    ##funcName = "".join(func)
                    #print(funcName,' / ',line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0])
                    #print('LOG','is equal',funcArray[i][1] , '==' , line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0])
                    if (funcArray[i][1] == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0] and funcArray[i][0]=='uncheck'):
                        #print(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0], line.split('\n')[0].partition('CMPChecker::')[2].split('=')[2])
                        #print('LOG','before update: ',funcArray[i],"/",funcArray[i][1])
                        funcArray[i][0]='check'
                        funcArray[i][2]=val #funcArray[0][i][3]=val
                        funcArray[i][3]=msg #funcArray[0][i][2]=msg
                        #print('LOG',i,'***** Parsed after update:',funcArray[i])
                    #else:
                        #funcArray[i].append(' ')
                        #funcArray[i].append(' ')
                        #print(i,'***** Parsed after update:',funcArray[i])
                    #i=i+1
                    #print('for end',i)
				#...................................
            elif datasize == 2:
                if ('feature list' == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
                    #wvrfeatureRSArray.append(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[0])
                    #wvrfeatureRSArray.append(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[1])
                    #wvrfeatureRSArray.append(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[2])
                    #wvrfeatureRSArray.append(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[3])
                    #wvrfeatureRSArray.append(line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[4])
                    try:
                        for i in range(len(featureArray)):
                            #print(i, 'wvr features support list:', line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[i])
                            #print('feature: ', featureArray[i][1], '/ state: ',  featureArray[i][0],',/ new: ', line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[i])
                            if (featureArray[i][0]=='uncheck' and line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[i] == '1'):
                                featureArray[i][0]='check'
                                featureArray[i][2]=1
                            elif (featureArray[i][0]=='uncheck' and line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1].split(',')[i] == '0'):
                                featureArray[i][0]='check'
                                featureArray[i][2]=0
                            #print('LOG\n',featureArray[i])
                    except IndexError:
                        print("Index should be smaller.")
                else:
				    #+++
                    key = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0] #split分隔字串不會留下
                    val = line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1] #split分隔字串不會留下

                    for i in range(len(appInfoArray)):
                        #print(featureArray[i][1], '/1 data: ',  line.split('\n')[0].partition('CMPChecker::')[2].split('='))
                        if (appInfoArray[i][0] == line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0]):
                            #print('LOG','appInfo:',line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0],', ',line.split('\n')[0].partition('CMPChecker::')[2].split('=')[1])
                            #appInfoArray[i][0]= key
                            appInfoArray[i][1]= val
                    #appInfoArray.append([key, val]) #ok
                    #appInfoArray.insert([0][0],[key, val])
                    #+++
                    #print(22222222222222222222)
            #elif datasize == 1: 
                #for i in range(len(featureArray)):
                    ##print('feature: ', featureArray[i][1], '/1 data: ',  line.split('\n')[0].partition('CMPChecker::')[2].split('='))
                    #if (featureArray[i][1] == line.split('\n')[0].partition('CMPChecker::')[2] and featureArray[i][0]=='uncheck'):
                        #featureArray[i][0]='check'
                        #featureArray[i][2]='1' 
                        ##print('need update feature support list', i, ', ',featureArray[i][0], ',', featureArray[i][2])
                #print('1111111111111111111')

            #print(len(line.partition('CMPChecker::')[2].split('=')))

            # for debug!!!
            #if 'CMPChecker::' in line: 
                #print('LOG','dump log to file',line.split('\n')[0])
                #data.append(line)
                #data.append("\n")
            # for debug!!!
            # at each line check for a match with a regex
            #key, match = _parse_line(line)
            line = file_object.readline() # while line, read next line 



        data.append('*********************** Summary output *********************************')
        print('\n\n*********************** Summary output *********************************')
        #print('InputMapper_DumpMap()=PairCount DST (id, capability, axis_type) SRC (id, capability, axis_type) devType')
        #SRC是DS(device service)端, DST是指client端
        #for i in range(len(inputMatchArrary)):
            #print('Debug\t\t\t',inputMatchArrary[i])

        data.append('\n**** App request key mapping result list:')
        print('\n**** App request key mapping result list:')
        for i in range(len(inputMatchArrary)):
            idx = int(inputMatchArrary[i][2])
            devType = int(inputMatchArrary[i][0])
            if (1==int(devType)):
                print('Device HMD input key mapping:',wvrInputArray[idx][2],',')
                data.append('Device HMD input key mapping:'+wvrInputArray[idx][2]+',')
            elif (2==int(devType)):
                print('Device Controller Right input key mapping:',wvrInputArray[idx][2],',')
                data.append('Device Controller Right input key mapping:'+wvrInputArray[idx][2]+',')
            elif (3==int(devType)):
                print('Device Controller Left input key mapping:',wvrInputArray[idx][2],',')
                data.append('Device Controller Left input key mapping:'+wvrInputArray[idx][2]+',')

				
        #print('HMD Button state get:', appGetHMDButtonArray)
        #print('HMD Touch state get:', appGetHMDTouchArray)
        #print('Left Button state get:', appGetLButtonArray)
        #print('Left Touch state get:', appGetLTouchArray)
        #print('Right Button state get:', appGetRButtonArray)
        #print('Right Touch state get:', appGetRTouchArray)
        data.append('\n**** App handle key mapping state:')
        print('\n**** App handle key mapping state:')
        #print(appGetLButtonArray)
        for i in range(len(appGetRButtonArray)):
            #print('Right Button state get:', appGetRButtonArray)
            if (1 == appGetRButtonArray[i]):
                print('Right input ButtonState: ', wvrInputArray[i],',')
                data.append('Right input ButtonState: '+ str(wvrInputArray[i])+',')
        for i in range(len(appGetLButtonArray)):
            if (1 == appGetLButtonArray[i]):
                print('Left input ButtonState: ', wvrInputArray[i],',')
                data.append('Left input ButtonState: '+ str(wvrInputArray[i])+',')

        for i in range(len(appGetRTouchArray)):
            #print('Right Button state get:', appGetRTouchArray)
            if (1 == appGetRTouchArray[i]):
                print('Right input TouchState: ', wvrInputArray[i],',')
                data.append('Right input TouchState: '+ str(wvrInputArray[i])+',')
        for i in range(len(appGetRTouchArray)):
            if (1 == appGetLTouchArray[i]):
                print('Left input TouchState: ', wvrInputArray[i],',')
                data.append('Left input TouchState: '+ str(wvrInputArray[i])+',')


        data.append('\n\n**** Application information:')
        print('\n\n**** Application information:')
        APKsdkVersion, APKtargetSdkVersion = prepareAndroidManifest()
        data.append('sdkVersion: '+APKsdkVersion+'\ntargetSdkVersion: '+APKtargetSdkVersion)
        for x in range(len(appInfoArray)):#len(d3), app amount
            #for i in range(len(appInfoArray[x])) :
                #print('(',x,i,')=',d3[x][i],',')
                ##print('\napp index:', x ,',/',len(appInfoArray))
                ##print('(x,i,j)','key',',','value')
                print(appInfoArray[x][0],': ',appInfoArray[x][1])
                data.append(str(appInfoArray[x][0])+': '+str(appInfoArray[x][1]))
                #if (x == 5):
                    #print('-->If it is not supported, it means that the default interactive mode is used.')
                    #data.append('-->If it is not supported, it means that the default interactive mode is used.')
                #elif (x ==6):
                    #print('-->If it is not supported, it means that the default game area boundary is used.')
                    #data.append('-->If it is not supported, it means that the default game area boundary is used.')
        data.append('\n\n**** WVR SDK Support features list:') #(runtime+SDK support result)
        print('\n\n**** WVR SDK Support features list:')
        for i in range(len(wvrfeatureArray)):
            if ((int(appInfoArray[1][1]) >= int(wvrfeatureArray[i][3])) and (int(appInfoArray[2][1]) >= int(wvrfeatureArray[i][3]))):
                if (' ' == wvrfeatureArray[i][5]):
                    print(wvrfeatureArray[i][1],': ','Support, If feature does not work need check DS.')
                    data.append(str(wvrfeatureArray[i][1])+': '+'Support, If feature does not work need check DS.')
                else:
                    print(wvrfeatureArray[i][1],': ','Support, API', wvrfeatureArray[i][5],': ','Support, If feature does not work need check DS.')
                    data.append(str(wvrfeatureArray[i][1])+': '+'Support, API'+ str(wvrfeatureArray[i][5])+': '+'Support, If feature does not work need check DS.')
            else:
                print('** ', wvrfeatureArray[i][1],': ','Not support')
                data.append('** '+ str(wvrfeatureArray[i][1])+': '+'Not support')


        data.append('\n**** WVR Support features list:') #(runtime support result by WVR_GetSupportedFeatures)
        print('\n**** WVR Support features list:')
        for i in range(len(featureArray)):
            #print(featureArray[i][1],'226: ',featureArray[i][2])
            #print(i ,' : ',  featureArray[i],'\n')
            if (not featureArray[i][1].startswith("none")):
                if ((featureArray[i][2]==1) and (int(appInfoArray[2][1]) >= int(featureArray[i][3]))):
                    if (' ' == featureArray[i][5]): #no need device service check
                        print('** [',i+1, ']', featureArray[i][1],': ','Support')
                        data.append('** '+ str(featureArray[i][1])+': '+'Support')
                    else:
                        print('** [',i+1, ']', featureArray[i][1],': ','Support, API', featureArray[i][5],': ','Support, If feature does not work need check DS.')
                        data.append('** '+ str(featureArray[i][1])+': '+'Support, API'+ str(featureArray[i][5])+': '+'Support, If feature does not work need check DS.')
                elif ((featureArray[i][2]==1) and (int(appInfoArray[2][1]) < int(featureArray[i][3]))):
                    print('** [',i+1, ']', featureArray[i][1],': ',' Not support by SDK version')
                    data.append('** '+ str(featureArray[i][1])+': '+'Not support by SDK version')
                else: # (featureArray[i][2]==0)
                    print('** [',i+1, ']', featureArray[i][1],': ','Not support by Runtime')
                    data.append('** '+ str(featureArray[i][1])+': '+'Not support by Runtime')
					

        data.append('\n**** API usage checklist:')
        print('\n**** API usage checklist:')
        #print(funcArray,'\n')
        count = 0
        unused = 0
        for i in range(len(funcArray)):
            #print(funcArray[i][1],'226: ',funcArray[i][2])
            #print(i ,' : ',  funcArray[i],'\n')
            #print('LOG',funcArray[i][1] , '==' , line.split('\n')[0].partition('CMPChecker::')[2].split('=')[0])
            if (funcArray[i][0]=='uncheck'):
                print(i+1,'** ', funcArray[i][1],': ','API function unused.')
                data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'API function unused.')
                unused = unused+1
            else:
                if ('WVR_StartHandTracking()' == funcArray[i][1]): 
                    print(i+1,'** ', funcArray[i][1],': ',funcArray[i][3])
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+str(funcArray[i][3]))
                    if (funcArray[i][3] == 'Success'):
                        count = count+1
                elif ('WVR_GetInteractionMode()' == funcArray[i][1] and funcArray[i][2] == '4'):
                    print(i+1,'** ', funcArray[i][1],': ','Pass to switch hand interaction mode')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Pass to switch hand interaction mode')
                    count = count+1
                elif ('WVR_GetInteractionMode()' == funcArray[i][1] and funcArray[i][2] == '3'):
                    print(i+1,'** ', funcArray[i][1],': ','Pass to switch controller interaction mode')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Pass to switch hand interaction mode')
                    count = count+1
                elif ('WVR_GetCurrentNaturalHandModel()' == funcArray[i][1]):
                    print(i+1,'** ', funcArray[i][1],': ',funcArray[i][3])
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+str(funcArray[i][3]))
                    if (funcArray[i][3] == 'Success'):
                        count = count+1
                elif (funcArray[i][2]=='1'): # or funcArray[i][2]=='4'
                    print(i+1,'** ', funcArray[i][1],': ','Pass')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Pass')
                    count = count+1
                elif (funcArray[i][2]=='Support'):
                    print(i+1,'** ', funcArray[i][1],': ','Support')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Support')
                    count = count+1
                elif (funcArray[i][2]=='Not support'):
                    print(i+1,'** ', funcArray[i][1],': ','Not support')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Not support')
                elif (funcArray[i][2]!='0'):
                    print(i+1,'** ', funcArray[i][1],': ','Pass')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'Pass')
                    count = count+1
                else:
                    print(i+1,'** ', funcArray[i][1],': ','fail, need content check')
                    data.append(str(i+1)+'** '+ str(funcArray[i][1])+': '+'fail, need content check')
        print('Total compatibility item: ' ,len(funcArray), ', Pass: ' ,count, ', Fail: ' ,(len(funcArray)-count-unused), ', Unuse: ', str(unused))
        data.append('Total compatibility item: ' +str(len(funcArray))+ ', Pass: ' +str(count)+ ', Fail: ' +str(len(funcArray)-count-unused)+ ', Unuse: ' +str(unused))

        #for i in range(len(funcArray)) : 
            #for j in range(len(funcArray[i])) : 
                #print(j,': ',funcArray[i][0], '/ ',funcArray[i][1])
                ##for k in range(len(funcArray[i][j])) : 
                    ##print(j,': ',funcArray[i][0], '/ ',funcArray[i][1]) 
                    ##print(i,': ',funcArray[i][j][0], '/' , funcArray[i][j][1], end=" ")
            #print('\n')
        #print('\n')

        data.append('\nDescription:')
        print('\nDescription:')
        if (int(funcArray[2][2]) == 1):
            pointArray[2] = '3 -> Interaction mode is SystemDefault.'
        elif (int(funcArray[2][2]) == 2):
            pointArray[2] = '3 -> Interaction mode is Gaze.'
        elif (int(funcArray[2][2]) == 3):
            pointArray[2] = '3 -> Interaction mode is Controller.'
        else:
            pointArray[2] = '3 -> Interaction mode is Hand.'

        for x in range(len(pointArray)):
           print(pointArray[x])
           data.append(pointArray[x])

        print('\n*********************** Summary output *********************************')
        data.append('\n*********************** Summary output *********************************')
        with open(outputfile, 'w') as f:
            for item in data:
                f.write("%s\n" % item)
        f.close()
    #print('------')



if __name__ == "__main__":
   main(sys.argv[1:])
